#!/bin/bash

source ./set_env.sh

#######################################################################
####################### Make sure that run as root ####################
#######################################################################

#if [ "$EUID" -ne 0 ]
#  then echo "Please run as root"
#  exit
#fi

#######################################################################
###################### Setting project paths ##########################
#######################################################################

topdirname="opt-pts"
projectpath="."
LOGDIR="${HOME}/Desktop/opt-pts-log/"

#######################################################################
############# Getting absolute path for project #######################
#######################################################################

# if [ -n "$1" ]
# then
    # top="$1"
# else
    # prg=$0

    # if [ ! -e "$prg" ]; then
      # case $prg in
        # (*/*) exit 1;;
        # (*) prg=$(command -v -- "$prg") || exit;;
      # esac
    # fi
    # dir=$(
      # cd -P -- "$(dirname -- "$prg")" && pwd -P
    # ) || exit
    # prg=$dir/$(basename -- "$prg") || exit 
    
    # top=$prg
    # while true
    # do
        # if [ `basename "$top"` == "$topdirname" ]
        # then
            # break;
        # else
            # top=`dirname "$top"`
        # fi
    # done
# fi




#######################################################################
####################### Drivers management ############################
#######################################################################



#######################################################################
############################## Logging ################################
#######################################################################


# create log directories
mkdir -p "$LOGDIR"


# get board serial
serial=0000
extra_serial=0000


serial=$1
if [ x$1 = x"" ]; then
	echo -n "Please scan CERN serial number bar-code, then press [ENTER]: "
        read serial
fi

if [ x$serial = x"" ]; then
	serial=0000
fi

extra_serial=$2
if [ x$2 = x"" ]; then
	echo -n "If needed input extra serial number and press [ENTER] OR just press [ENTER]: "
        read extra_serial
fi

if [ x$extra_serial = x"" ]; then
	extra_serial=0000
fi

echo " "

board_plugged=$3
echo -n "---> Now please plug in the board and then press [ENTER]"
read board_plugged

nb_test_limit=2
nb_test=1


#######################################################################
############################## Testing  ###############################
#######################################################################


while [ "$nb_test" -le "$nb_test_limit" ]
do
    echo "--------------------------------------------------------------"
    echo "Test series run $nb_test out of $nb_test_limit"
    echo " "

    # run tests
    #sudo ${top}/pts/pts-opt.py -b pts-opt -s $serial -e $extra_serial "-t${top}/python" -l $LOGDIR 00 01
    sudo ./pts.py -b OptRtm -s $serial -e $extra_serial -t./python -l $LOGDIR 00 01 02


    # repeat test?
    if [ "$nb_test" != "$nb_test_limit" ]
    then
        echo " "
        echo -n "Do you want to run the test series again [y,n]? "
        read reply
        if [ "$reply" != "y" ]
        then
            
            break
        fi
    fi
    nb_test=$(($nb_test+1))
done

echo "--------------------------------------------------------------"
echo " "
echo -n "End of the test, do you want to switch the computer OFF? [y,n]"
read reply
if [ "$reply" = "y" ]
then
    sudo poweroff
fi

