#!/usr/bin/env python

# Copyright CERN, 2019
# Author: <Dimitris.Lampridis@cern.ch>, <Evangelia.Gousiou@cern.ch>
# Licence: GPL v2 or later.
# Website: http://www.ohwr.org

###TODO: add switching ON of the vme crate 

import sys
import os
import string
import time

sys.path.append('..')
import utilities as util
import ptsexcept


def test_led_all():
    
    util.section_msg("Testing LEDs OFF state")

    if not util.ask_user("Are all LEDs OFF now?"):
        util.err_msg("Some LEDs might be broken")
        return 0

    util.section_msg("Testing LEDs ON state")
    util.user_msg("---> Now make all the front panel connections and press [ENTER]")
    ret = raw_input("") 
    # switch ON VME crate now..
	# loop vv_read of BIDR reg to check when initialization is completed
	
    if not util.ask_user("Are all LEDs ON now?"):
        util.err_msg("Some LEDs or other board components might be broken")
        return 0
       
    util.info_msg("All LEDs verified successfully!")
    return 1
    


def main (card=None, default_directory='.',suite=None, serial=""):
    
    testname= "Test00: LEDs and basic connectivity"
    util.header_msg( testname, [ "LED connectivity"] )
    
    ###############################################################################
    ############################ initialization ###################################
    ###############################################################################
    test_results={}
    

    ###############################################################################
    ############################ actual test ######################################
    ###############################################################################
    test_results['LEDs'] = test_led_all()

    ###############################################################################
    ########################## result processing ##################################
    ###############################################################################
    errors = util.summarise_test_results( testname, test_results)

    sys.stdout.flush()
    return 0;
        
if __name__ == '__main__' :
    main()