#!/usr/bin/env python

# Copyright CERN, 2019
# Author: <Dimitris.Lampridis@cern.ch>, <Evangelia.Gousiou@cern.ch>
# Licence: GPL v2 or later.
# Website: http://www.ohwr.org

###TODO: it seems the test passes when there is no CTR in the crate:-o

import os
import string
import time
import sys

sys.path.append('..')
import utilities as util
import ptsexcept


def get_ctrtest_err(module):

    cmd = 'echo "mo {0} rst" | /usr/local/bin/ctrtest-timdt | grep -A 7 -e MsMissedErrs | xargs'.format(module)
    output = os.popen(cmd).read()
    
    items  = string.split(output)

    mserr   = '{0} {1} {2}'.format(items[1][1:],  items[3][1:],  items[4])
    pllerr  = '{0} {1} {2}'.format(items[6][1:],  items[8][1:],  items[9])
    misserr = '{0} {1} {2}'.format(items[11][1:], items[13][1:], items[14])

    return mserr, pllerr, misserr



def main (card=None, default_directory='.',suite=None, serial=""):

    testname= "Test02: GMT transmission/ recetion"
    util.header_msg( testname, [ "GMT transmission/ reception"] )
	
    ###############################################################################
    ############################ initialization ###################################
    ###############################################################################
 
    test_results={}
    result={}

    ms1   = [0, 0, 0, 0]
    pll1  = [0, 0, 0, 0]
    miss1 = [0, 0, 0, 0]
    
    ###############################################################################
    ############################ actual test ######################################
    ###############################################################################
    for i in range(0,4):
        ms1[i], pll1[i], miss1[i] =  get_ctrtest_err(i+1)

    #time.sleep(60.0)
    time.sleep(3.0)

    ms2   = [0, 0, 0, 0]
    pll2  = [0, 0, 0, 0]
    miss2 = [0, 0, 0, 0]

    errors = False

    for i in range(0,4):
        ms2[i], pll2[i], miss2[i] =  get_ctrtest_err(i+1)

        if (ms1[i] != ms2[i]):
            result['Ms errors'] = 0
            util.err_msg("Module %d: Ms errors detected"%(i+1))
            #errors = True
            #print 'Module {0}: Ms errors detected ({1} != {2})'.format(i+1, ms2[i], ms1[i])

        if (pll1[i] != pll2[i]):
	    result['PLL errors'] = 0
            util.err_msg("Module %d: PLL errors detected"%(i+1))
            #errors = True
            #print 'Module {0}: PLL errors detected ({1} != {2})'.format(i+1, pll2[i], pll1[i])

        if (miss1[i] != miss2[i]):
	    result['Missed errors'] = 0
	    util.err_msg("Module %d: Missed errors detected"%(i+1))
            #errors = True
            #print 'Module {0}: Missed errors detected ({1} != {2})'.format(i+1, miss2[i], miss1[i])

    ###############################################################################
    ########################## result processing ##################################
    ###############################################################################
    if not result:
        util.info_msg("All transmitters/receivers have been validated OK")
    else:
        util.err_msg("Board funtionality not validated")
	
	errors = util.merge_dictionaries( test_results, result)
	sys.stdout.flush()
    return 0
        
if __name__ == '__main__' :
    main()